import { defineComponent as E, mergeDefaults as P, ref as v, computed as W, unref as t, openBlock as f, createElementBlock as u, createElementVNode as n, toDisplayString as m, normalizeClass as c, Fragment as L, createCommentVNode as I } from "vue";
import { useFormWidget as M } from "./FormWidget.js";
import { useConfig as N } from "../config.js";
const _ = {
  key: 0,
  class: "cfb-flex cfb-justify-between cfb-w-full"
}, D = ["required", "type", "value", "minlength", "maxlength", "pattern", "id"], F = {
  key: 0,
  class: "cfb-mt-1 cfb-text-sm cfb-text-danger-600"
}, A = /* @__PURE__ */ E({
  __name: "PasswordWidget",
  props: /* @__PURE__ */ P({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    maxLength: {},
    minLength: {},
    pattern: {},
    empty: {},
    mask: {},
    widgetId: {}
  }, N("PasswordWidget", {
    empty: "N/A",
    mask: "••••••••••••"
  })),
  setup(y) {
    const s = y, o = v(), a = v(!1), {
      value: d,
      isRequired: h,
      setValue: b,
      register: w,
      validatedMeta: r,
      validator: k,
      validate: x,
      isValid: i,
      view: q
    } = M("PasswordWidget", s);
    w({ validator: () => {
      var l;
      let e = o.value;
      return k(), e && (r.value.validity = e.checkValidity(), e.validationMessage && ((l = r.value).err ?? (l.err = [{ msg: e.validationMessage }]))), r.value;
    }, el: o });
    const C = (e) => {
      e.target.value === "" ? b(void 0) : b(e.target.value), x();
    }, V = W(() => s.pattern instanceof RegExp ? s.pattern.source : s.pattern);
    return (e, l) => {
      var g, p;
      return t(q) ? (f(), u("div", _, [
        n("div", null, m(a.value ? t(d) ?? e.empty : e.mask), 1),
        n("button", {
          type: "button",
          class: "cfb-aspect-square cfb-w-7 cfb-rounded-lg hover:cfb-bg-gray-400",
          onClick: l[0] || (l[0] = (B) => a.value = !a.value)
        }, [
          n("i", {
            class: c(["fa-solid", a.value ? "fa-eye" : "fa-eye-slash"])
          }, null, 2)
        ])
      ])) : (f(), u(L, { key: 1 }, [
        n("div", {
          class: c([
            "cfb-items-center cfb-flex cfb-pr-1 cfb-rounded-lg cfb-min-w-0 cfb-w-full cfb-appearance-none",
            {
              "cfb-bg-valid-100 hover:cfb-bg-valid-200": t(i)() == !0,
              "cfb-bg-danger-100 hover:cfb-bg-danger-200": t(i)() == !1,
              "cfb-bg-gray-200 hover:cfb-bg-gray-300": t(i)() == null
            }
          ])
        }, [
          n("input", {
            required: t(h)(),
            class: "cfb-flex-grow cfb-bg-opacity-0 cfb-bg-white cfb-p-1.5 cfb-rounded-lg focus:cfb-outline-none cfb-w-full cfb-appearance-none",
            type: a.value ? "text" : "password",
            onInput: C,
            value: t(d) || "",
            minlength: e.minLength,
            maxlength: e.maxLength,
            pattern: V.value,
            ref_key: "inputEl",
            ref: o,
            id: e.widgetId ?? e.path
          }, null, 40, D),
          n("button", {
            type: "button",
            class: "cfb-aspect-square cfb-w-7 cfb-rounded-lg hover:cfb-bg-gray-400",
            onClick: l[1] || (l[1] = (B) => a.value = !a.value)
          }, [
            n("i", {
              class: c(["fa-solid", a.value ? "fa-eye" : "fa-eye-slash"])
            }, null, 2)
          ])
        ], 2),
        (p = (g = t(r)) == null ? void 0 : g.err) != null && p[0].msg ? (f(), u("span", F, m(t(r).err[0].msg), 1)) : I("", !0)
      ], 64));
    };
  }
});
export {
  A as default
};
