import { defineComponent as x, mergeDefaults as E, ref as H, unref as t, openBlock as n, createElementBlock as d, Fragment as _, createElementVNode as k, normalizeClass as L, toDisplayString as B, createCommentVNode as M } from "vue";
import { useConfig as V } from "../config.js";
import { useFormWidget as T } from "./FormWidget.js";
const q = ["innerHTML"], A = ["id", "placeholder", "required", "value", ".rows"], C = {
  key: 0,
  class: "cfb-mt-1 cfb-text-sm cfb-text-danger-600"
}, F = /* @__PURE__ */ x({
  __name: "TextAreaWidget",
  props: /* @__PURE__ */ E({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    default: {},
    maxLength: {},
    minLength: {},
    empty: {},
    rows: {},
    autoExpandHeight: { type: Boolean },
    heightLimit: {},
    widgetId: {},
    placeholder: {}
  }, V("TextAreaWidget", {
    empty: "N/A",
    rows: 5,
    autoExpandHeight: !0,
    heightLimit: 500
  })),
  setup(p) {
    const i = p, a = H(), {
      value: s,
      isRequired: f,
      setValue: g,
      register: h,
      validatedMeta: r,
      validator: m,
      validate: v,
      isValid: l,
      view: b
    } = T("TextAreaWidget", i);
    h({ validator: () => {
      var o;
      let e = a.value;
      return m(), e && (r.value.validity = e.checkValidity(), e.validationMessage && ((o = r.value).err ?? (o.err = [{ msg: e.validationMessage }]))), r.value;
    }, el: a });
    const y = () => {
      a.value && i.autoExpandHeight && (a.value.style.height = "", a.value.style.height = Math.min(a.value.scrollHeight, i.heightLimit) + "px");
    }, w = (e) => {
      y(), e.target.value === "" ? g(void 0) : g(e.target.value), v();
    };
    return (e, o) => {
      var u, c;
      return t(b) ? (n(), d("pre", {
        key: 0,
        class: "cfb-whitespace-pre-wrap cfb-font-sans",
        innerHTML: t(s) ?? e.empty
      }, null, 8, q)) : (n(), d(_, { key: 1 }, [
        k("textarea", {
          id: e.widgetId ?? e.path,
          ref_key: "textEl",
          ref: a,
          placeholder: e.placeholder,
          required: t(f)(),
          class: L([
            "cfb-rounded-lg cfb-p-1.5 cfb-min-w-0 cfb-w-full",
            {
              "cfb-bg-valid-100 hover:cfb-bg-valid-200": t(l)() == !0,
              "cfb-bg-danger-100 hover:cfb-bg-danger-200": t(l)() == !1,
              "cfb-bg-gray-200 hover:cfb-bg-gray-300": t(l)() == null
            }
          ]),
          onInput: w,
          value: t(s) || "",
          ".rows": e.rows
        }, `
        `, 42, A),
        (c = (u = t(r)) == null ? void 0 : u.err) != null && c[0].msg ? (n(), d("span", C, B(t(r).err[0].msg), 1)) : M("", !0)
      ], 64));
    };
  }
});
export {
  F as default
};
