export var LocalStorage;
(function (LocalStorage) {
    function set(key, value) {
        localStorage.setItem(key, JSON.stringify(value));
    }
    LocalStorage.set = set;
    function get(key) {
        let item = localStorage.getItem(key);
        try {
            if (item)
                item = JSON.parse(item);
        }
        catch { }
        return item;
    }
    LocalStorage.get = get;
    function remove(key) {
        localStorage.removeItem(key);
    }
    LocalStorage.remove = remove;
})(LocalStorage || (LocalStorage = {}));
