import { defineComponent as w, mergeDefaults as x, ref as C, unref as t, openBlock as c, createElementBlock as n, Fragment as E, createTextVNode as N, toDisplayString as g, createElementVNode as r, normalizeClass as p, createCommentVNode as q } from "vue";
import { useFormWidget as M } from "./FormWidget.js";
import { useConfig as W } from "../config.js";
const I = {
  key: 1,
  class: "cfb-grid"
}, D = /* @__PURE__ */ r("div", { class: "cfb-w-5 cfb-h-5 cfb-shadow cfb-bg-white cfb-rounded-3xl" }, null, -1), F = [
  D
], H = ["required", "checked", "id"], T = {
  key: 0,
  class: "cfb-mt-1 cfb-text-sm cfb-text-danger-600"
}, S = /* @__PURE__ */ w({
  __name: "BooleanWidget",
  props: /* @__PURE__ */ x({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    empty: {},
    trueVal: {},
    falseVal: {},
    widgetId: {}
  }, W("BooleanWidget", {
    empty: "N/A",
    trueVal: "Y",
    falseVal: "N"
  })),
  setup(m) {
    const v = m, o = C(), {
      value: a,
      schema: h,
      isRequired: y,
      setValue: d,
      register: k,
      validatedMeta: l,
      validator: V,
      validate: _,
      view: s,
      isValid: f
    } = M("BooleanWidget", v);
    k({ validator: () => {
      var i;
      let e = o.value;
      return V(), e && (l.value.validity = e.checkValidity(), e.validationMessage && ((i = l.value).err ?? (i.err = [{ msg: e.validationMessage }]))), l.value;
    }, el: o });
    const B = (e) => {
      e.target instanceof HTMLInputElement && (d(e.target.checked), _());
    };
    return a.value == null && d(h.value.defaultValue ?? !1), (e, i) => {
      var u, b;
      return t(s) ? (c(), n(E, { key: 0 }, [
        N(g(t(a) ?? e.empty), 1)
      ], 64)) : (c(), n("div", I, [
        r("button", {
          onClick: i[0] || (i[0] = (A) => {
            t(s) || o.value.click();
          }),
          type: "button",
          class: p([
            "cfb-w-14 cfb-mb-2 cfb-h-7 cfb-rounded-3xl cfb-relative cfb-cursor-pointer",
            {
              "cfb-bg-valid-400 hover:cfb-bg-valid-500": t(a) == !0,
              "cfb-bg-danger-100 hover:cfb-bg-danger-200": t(f)() == !1,
              "cfb-bg-gray-200 hover:cfb-bg-gray-300": t(f)() == null
            }
          ])
        }, [
          r("div", {
            class: p([
              "cfb-grid cfb-items-center cfb-h-full cfb-top-0 cfb-absolute cfb-px-1 cfb-transition-all",
              t(a) ? "cfb-left-[calc(100%-1.7rem)]" : "cfb-left-0"
            ])
          }, F, 2)
        ], 2),
        r("input", {
          ref_key: "inputEl",
          ref: o,
          class: "cfb-hidden",
          type: "checkbox",
          onChange: B,
          required: t(y)(),
          checked: t(a),
          id: e.widgetId ?? e.path
        }, null, 40, H),
        (b = (u = t(l)) == null ? void 0 : u.err) != null && b[0].msg ? (c(), n("span", T, g(t(l).err[0].msg), 1)) : q("", !0)
      ]));
    };
  }
});
export {
  S as default
};
