import { defineComponent as $, mergeDefaults as M, ref as V, unref as c, openBlock as d, createElementBlock as f, Fragment as v, createTextVNode as E, toDisplayString as m, normalizeClass as q, createElementVNode as i, renderList as N, createCommentVNode as W } from "vue";
import { useConfig as D } from "../config.js";
import { useEnum as j } from "../enum.js";
import { useFormWidget as z } from "./FormWidget.js";
const F = { class: "cfb-flex cfb-flex-wrap cfb-gap-4" }, R = { class: "cfb-flex cfb-gap-2 cfb-items-center" }, S = ["for"], H = ["id", "value", "checked", "onClick"], L = { class: "cfb-flex cfb-gap-2" }, O = {
  key: 0,
  class: "cfb-mt-1 cfb-text-sm cfb-text-danger-600"
}, X = /* @__PURE__ */ $({
  __name: "CheckBoxWidget",
  props: /* @__PURE__ */ M({
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    empty: {},
    minItems: {},
    maxItems: {},
    widgetId: {},
    selectAllText: {},
    deselectAllText: {},
    enum: {},
    enumMapperKey: {},
    disableEnumMapping: { type: Boolean },
    enumMapper: {}
  }, D("CheckBoxWidget", {
    empty: "N/A",
    minItems: 0,
    selectAllText: "Select All",
    deselectAllText: "Deselect All"
  })),
  setup(x) {
    const b = V(), s = x, { mappedEnum: p } = j(s), {
      value: t,
      isRequired: h,
      setValue: n,
      register: k,
      validatedMeta: l,
      validator: y,
      validate: u,
      view: _,
      isValid: I
    } = z("CheckBoxWidget", s);
    t.value == null && n([]);
    const A = () => {
      var e, r, a;
      return y(), s.minItems != null && t.value.length < s.minItems ? (l.value.validity = !1, (e = l.value).err ?? (e.err = [{ msg: `Minimum ${s.minItems} items required` }])) : s.maxItems != null && t.value.length > s.maxItems ? (l.value.validity = !1, (r = l.value).err ?? (r.err = [{ msg: `Maximum ${s.maxItems} items allowed` }])) : h() && t.value.length === 0 && (l.value.validity = !1, (a = l.value).err ?? (a.err = [{ msg: "Required" }])), l.value;
    }, C = (e) => {
      const r = t.value.includes(e);
      n(r ? t.value.filter((a) => a !== e) : [...t.value, e]), u();
    }, w = () => {
      n(Object.keys(p.value)), u();
    }, B = () => {
      n([]), u();
    };
    return k({ validator: A, el: b }), (e, r) => {
      var a, g;
      return c(_) ? (d(), f(v, { key: 0 }, [
        E(m(c(t).join(",")), 1)
      ], 64)) : (d(), f("div", {
        key: 1,
        ref_key: "el",
        ref: b,
        class: q([
          "cfb-grid cfb-gap-2 cfb-p-2 cfb-rounded-lg",
          {
            "cfb-bg-danger-100": c(I)() == !1
          }
        ])
      }, [
        i("div", F, [
          i("div", R, [
            (d(!0), f(v, null, N(c(p), (T, o) => (d(), f("label", {
              for: `${e.widgetId ?? e.path}-${o}`,
              class: "cfb-border-main-500 cfb-flex cfb-items-center cfb-gap-2 cfb-border cfb-rounded-lg cfb-px-2 cfb-py-1 cfb-min-w-28"
            }, [
              i("input", {
                id: `${e.widgetId ?? e.path}-${o}`,
                class: "cfb-size-4",
                type: "checkbox",
                value: o,
                checked: c(t).includes(o),
                onClick: (P) => C(o)
              }, null, 8, H),
              i("div", null, m(T), 1)
            ], 8, S))), 256))
          ])
        ]),
        i("div", L, [
          i("button", {
            class: "cfb-bg-main-600 cfb-text-white cfb-px-2 cfb-py-1 cfb-rounded-lg cfb-text-sm",
            onClick: w
          }, m(e.selectAllText), 1),
          i("button", {
            class: "cfb-bg-main-600 cfb-text-white cfb-px-2 cfb-py-1 cfb-rounded-lg cfb-text-sm",
            onClick: B
          }, m(e.deselectAllText), 1)
        ]),
        (g = (a = c(l)) == null ? void 0 : a.err) != null && g[0].msg ? (d(), f("span", O, m(c(l).err[0].msg), 1)) : W("", !0)
      ], 2));
    };
  }
});
export {
  X as default
};
